<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Model\DataLayerGa4\Generator;

use Flat101\EnhancedEcommerce\Model\DataLayerGa4\Builder\ImpressionBuilder as ImpressionBuilderGa4;
use Flat101\EnhancedEcommerce\Model\DataLayer\Dto;
use Flat101\EnhancedEcommerce\Model\DataLayerGa4\Dto as DataLayerDtoGa4;
use Flat101\EnhancedEcommerce\Model\UnsetProperty;
use Magento\Catalog\Model\Product as ProductEntity;
use Magento\Store\Model\StoreManagerInterface;

class AddToCartImpression
{
    use UnsetProperty;

    public const EVENT = 'add_to_cart';

    /** @var ImpressionBuilderGa4 */
    private $impressionBuilderGa4;

    /** @var StoreManagerInterface */
    private $storeManager;

    public function __construct(
        ImpressionBuilderGa4 $impressionBuilderGa4,
        StoreManagerInterface $storeManager
    ) {
        $this->impressionBuilderGa4 = $impressionBuilderGa4;
        $this->storeManager = $storeManager;
    }

    public function generate(ProductEntity $entity, string $list, $additionalInfo = null): Dto\Ecommerce
    {
        $detailsDto = new DataLayerDtoGa4\EcommerceDetails();
        $detailsDto->currency = $this->storeManager->getStore()->getCurrentCurrency()->getCode();
        $detailsDto->items[] = $this->impressionBuilderGa4->build($entity, $list, $additionalInfo);

        $ecommerce = new Dto\Ecommerce();
        $ecommerce->event = static::EVENT;
        $ecommerce->ecommerce = $detailsDto;

        $this->unset($ecommerce, ['eventCategory','eventAction','eventLabel']);

        //TODO: Check the structure
        return $ecommerce;
    }
}
