<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Plugin;

use Flat101\EnhancedEcommerce\Helper\AnalyticsConnector;
use Flat101\EnhancedEcommerce\Model\DataLayerGa4\Generator\CheckoutStep as CheckoutStepGa4;
use Flat101\EnhancedEcommerce\Model\Session AS CustomSession;
use Magento\Sales\Api\Data\OrderInterface;
use Magento\Sales\Api\OrderManagementInterface;
class OrderManagementPlugin
{
    CONST EVENT_NAME = 'add_payment_info';

    /** @var CheckoutStepGa4 */
    private $checkoutStepGa4;

    /** @var CustomSession */
    private $customSession;

    /** @var AnalyticsConnector */
    private $analyticsConnector;

    public function __construct(
        CheckoutStepGa4 $checkoutStepGa4,
        CustomSession $customSession,
        AnalyticsConnector $analyticsConnector
    ) {
        $this->checkoutStepGa4 = $checkoutStepGa4;
        $this->customSession = $customSession;
        $this->analyticsConnector = $analyticsConnector;
    }

    public function afterPlace(
        OrderManagementInterface $subject,
        OrderInterface $result
    ) {
        $this->analyticsConnector->sendOrderToGoogle($result);

        $this->customSession->setCheckoutStep(
            $this->checkoutStepGa4->onCheckoutStep(self::EVENT_NAME, $result)
        );
        return $result;
    }
}
